What Is a QR Code? How QR Codes Work and What They Hold

A QR code is a square 2D barcode that stores a web address, text or other data in a grid of dark and light modules. A phone camera reads it and offers to open the link or show the content. This guide explains how QR codes work, what they can hold and how to scan one.

By the Barcode.codes editorial teamReviewed

What a QR Code Is

A QR code, short for Quick Response code, is a two-dimensional barcode: square modules in a square grid, found by the finder patterns at three of its corners.

What a QR Code Looks Like

A QR code of 25 × 25 modules holding https://barcode.codes/, with its parts marked: the three finder patterns in the corners, dark modules for binary 1, light modules for binary 0, and the 4-module quiet zone around it.
A QR code of 25 × 25 modules holding https://barcode.codes/: the three finder patterns in the corners, dark modules for 1 and light modules for 0, and the quiet zone of four modules around it.

A QR code is 21 × 21 modules at version 1 and grows by four modules per side up to 177 × 177 at version 40. It needs a blank margin of four modules, the quiet zone, on every side.

A Standard Anyone Can Use

QR Code is defined by the international standard ISO/IEC 18004, and GS1 has adopted it for product data. A code made to the standard works with any reader that supports it, not only with the site that made it.

QR code vs barcode how a QR code differs from a 1D barcode and when to use each.

How Do QR Codes Work?

A QR code turns data into bits, adds error correction, and writes the bits as dark and light modules; a scanner finds the grid from the finder patterns and reads the bits back.

From Characters to Modules

QR Code has modes for digits, for capital letters with digits and nine symbols, and for bytes of any text, and the fewer kinds of characters, the more fit. At version 40 with the lowest error correction a QR code holds 7,089 digits, 4,296 capitals and digits, or 2,953 bytes.

A dark module is a binary 1 and a light module a 0. The encoder picks the smallest version that holds the data at the chosen error correction level, which is why a longer web address gives a denser code.

Error Correction

A QR code adds Reed-Solomon codewords, the same kind of error correction used on music CDs, so it can be read when part of it is dirty or missing. DENSO WAVE explains that correcting one codeword takes two extra ones, and gives the strength as a share of all codewords, from about 7% to 30%.

QR code generator lets you choose the error correction level and shows the version.

Read at Any Angle

The three finder patterns show the scanner where the code is and which way it faces, so a QR code reads at any rotation and even mirrored. The standard also allows light modules on a dark background, as an optional feature.

What a QR Code Can Hold

A QR code holds text, and phones act on text written in known formats: a web address opens a page, and other formats join a Wi-Fi network, save a contact or start a message.

Common QR code contents and the standard each format follows
ContentWhat the code holds
Web addresshttps://barcode.codes/
Wi-Fi network (ZXing format)WIFI:T:WPA;S:Cafe Guest;P:coffee-2026;;
Contact card (vCard 3.0, RFC 2426)BEGIN:VCARD … END:VCARD
Email (RFC 6068)mailto:support@barcode.codes
Phone call (RFC 3966)tel:+12125550100
Text message (RFC 5724)sms:+12125550100
Plain text (no format)Hello from Barcode.codes

QR code generator for Wi-Fi writes the Wi-Fi format for you, escaping special characters.

vCard QR code generator builds the contact card from a form.

How to Scan a QR Code With a Phone

Point the phone's camera at the code and tap the link or the result that appears; no separate app is needed on an iPhone.

  1. Open the Camera app, or the Scan Code control in Control Center on an iPhone.
  2. Hold the phone so the whole code, with its blank margin, is in the frame.
  3. Check the address or the result shown, then tap it to open it.

The Barcode.codes scanner reads QR codes in the browser on phones and computers. It shows a link in full, with its host, and never opens it by itself.

QR code scanner reads QR codes with your camera.

QR code reader reads QR codes from a photo or a screenshot.

Frequently Asked Questions

What Does QR Stand For?

Quick Response. Apple's iPhone guide calls them Quick Response (QR) codes, and the encoder's documentation lists Quick Response Code as the symbology's full name.

How Much Data Can a QR Code Hold?

Up to 7,089 digits, 4,296 capitals and digits, or 2,953 bytes of text, in the largest version with the lowest error correction. Most codes hold far less, because a dense code is harder to scan from a distance.

Do QR Codes Expire?

The code itself does not: its content is written in the pattern. A code that holds a link stops being useful when the linked page goes away, including a short link whose service later shuts down.

Is It Safe to Scan a QR Code?

Scanning only reads the content; the risk is in what you open next. Read the address before you tap it: phones and the Barcode.codes scanner show it first.

Can a QR Code Have Colors?

Yes, if the dark modules stay clearly darker than the light ones. The Barcode.codes generator estimates the contrast of your colors and refuses pairs below 20%.

Sources

The facts in this guide come from these sources, checked on October 8, 2026 from the copies saved on October 4, 2026.

GS1 General Specifications, Release 26.0, ratified January 2026 defines the GS1 identification keys, barcodes and Application Identifiers; the text names the sections used.

DENSO WAVE: Information capacity and versions of QR Code describes versions 1 to 40 and how the version is chosen for the data.

DENSO WAVE: QR Code error correction feature gives the share of codewords each QR error correction level can restore.

Apple iPhone User Guide: Scan a QR code describes reading QR codes with the iPhone Camera app.

BWIPP: QR Code symbology reference documents the QR Code encoder the generator uses, its standards and the automatic version choice.

ZXing: Barcode Contents lists the content formats phones recognize in QR codes, such as web addresses, Wi-Fi and contacts.